"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const is_plain_object_1 = __importDefault(require("is-plain-object"));
exports.propertyListener = (data) => {
    if (!is_plain_object_1.default(data)) {
        throw new Error('Data must be a plain object!');
    }
    const proxy = {};
    const gotKeys = new Set();
    let isActive = true;
    Object.keys(data).forEach((property) => {
        Object.defineProperty(proxy, property, {
            enumerable: true,
            configurable: true,
            set: (value) => data[property] = value,
            get: () => {
                if (isActive) {
                    gotKeys.add(property);
                }
                return data[property];
            }
        });
    });
    return {
        proxy,
        gotKeys,
        stop: () => { isActive = false; }
    };
};
