"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const propertyListener_1 = require("../Store/propertyListener");
const hasIntersection = (set1, set2) => {
    const smallestSet = set1.size < set2.size ? set1 : set2;
    const biggestSet = set1 === smallestSet ? set2 : set1;
    let result = false;
    smallestSet.forEach((key) => {
        if (biggestSet.has(key)) {
            result = true;
        }
    });
    return result;
};
exports.createHook = (store) => {
    const useStore = () => {
        const [listenObject, setListenObject] = react_1.useState(propertyListener_1.propertyListener(store.getState()));
        const [state, setState] = react_1.useState(listenObject.proxy);
        const [wasIndexed, setWasIndexed] = react_1.useState(false);
        react_1.useEffect(() => {
            return store.subscribe((newState, changedProps) => {
                if (!wasIndexed) {
                    listenObject.stop();
                }
                if (hasIntersection(changedProps, listenObject.gotKeys)) {
                    if (!wasIndexed) {
                        setWasIndexed(true);
                        setListenObject({
                            stop: () => { },
                            gotKeys: listenObject.gotKeys,
                            proxy: {}
                        });
                    }
                    setState(newState);
                }
            });
        }, [wasIndexed, state]);
        return Object.assign(Object.assign({}, state), store.actions);
    };
    return { useStore };
};
